package ca.sanae.golemcomputers.computer.components

import ca.sanae.golemcomputers.GolemComputers
import ca.sanae.golemcomputers.computer.Computer
import kotlinx.io.bytestring.decodeToString
import kotlinx.io.bytestring.getByteString
import net.minecraft.text.Text
import java.nio.ByteBuffer

class ChatComponent(private val computer: Computer) :
  Component(GolemComputers.id("chat"), GolemComputers.id("string_stream"), 10000, 0u) {
  var chatBuffer: String = ""
  override fun gotByteChunk(buffer: ByteBuffer) {
    chatBuffer += buffer.getByteString().decodeToString()
    while (true) {
      val index = chatBuffer.indexOf('\u0000')
      if (index == -1) break
      val (message, new) = chatBuffer.splitAtIndex(index)
      chatBuffer = new
      computer.world.server!!.sendMessage(Text.of(message))
    }
  }

  override fun restarted() {
    chatBuffer = ""
  }

  fun String.splitAtIndex(index: Int) = take(index) to substring(index)
}